#!/usr/bin/python
# -*- coding: utf8 -*-
## Script to open ebooks in kde
#
# License: GPL-2
# Author: mattepiu
#
#
#  Original code modified:
#  pyParts.py (C) 2002 Jim Bublitz <jbublitz@nwinternet.com>
#

from kdecore import KCmdLineArgs, KURL, KApplication, i18n, KAboutData, BarIcon, KLibLoader, i18n

from kdeui import KMainWindow, KMessageBox, KAction, KStdAction, KKeyDialog, KEditToolbar, KListView

from qt import  QString, QStringList, QListViewItem, QScrollView, SIGNAL, QPopupMenu

from kio import KTrader

from khtml import KHTMLPart, KHTMLView

# Importing the KParts namespace gets us all of the KParts:: classes
from kparts import KParts, createReadOnlyPart, createReadWritePart

import sys, os, zipfile, re, array

import xml.dom.minidom

from xml.dom.minidom import Node

FALSE = 0
TRUE  = not FALSE

TOOLBAR_EXIT = 0
TOOLBAR_OPEN = 1

# Note that we use KParts.MainWindow, not KMainWindow as the superclass
# (KParts.MainWindow subclasses KMainWindow). Also, be sure the 'apply'
# clause references KParts.MainWindow - it's a hard bug to track down
# if it doesn't.

def uprint(stamp):
    if debugx:
        print stamp

class pyPartsMW (KParts.MainWindow):
        def __init__ (self, *args):
                apply (KParts.MainWindow.__init__, (self,) + args)

                # Create the actions for our menu/toolbar to use
                # Keep in mind that the part loaded will provide its
                # own menu/toolbar entries

                # check out KParts.MainWindow's ancestry to see where
                # some of this and later stuff (like self.actionCollection () )
                # comes from

                #quitAction    = KStdAction.quit (self.close, self.actionCollection ())

                self.initActions ()
                self.initMenus ()
                self.m_toolbarAction = KStdAction.showToolbar(self.optionsShowToolbar, self.actionCollection());
                self.m_statusbarAction = KStdAction.showStatusbar(self.optionsShowStatusbar, self.actionCollection());

                KStdAction.keyBindings(self.optionsConfigureKeys, self.actionCollection());
                KStdAction.configureToolbars(self.optionsConfigureToolbars, self.actionCollection());

                self.path = os.getcwd () + '/'
                self.setGeometry (0, 0, 640, 500)
                self.setMinimumWidth(640)
                self.setMinimumHeight(440)
                uprint(self.geometry)
                self.myzoom = 100

                # point to our XML file
                self.setXMLFile (self.path + "pyParts.rc", FALSE)

                # The next few lines are all that's necessary to
                # create a web browser (of course you have to edit
                # this file to change url's)

                self.w   = KHTMLPart (self, "HTMLPart", self);
                uprint('zip:' + os.path.abspath(filelist_args[0]) + '/' + theDir + '/' + myhfile)
                self.w.openURL (KURL ('zip:' + os.path.abspath(filelist_args[0]) + '/' + theDir + '/' + myhfile));
                #self.w.openURL (KURL ('zip:' + os.path.join(filelist_args[0], theDir) + '/' + myhfile));

                self.w.view ().setGeometry (Xstart, 24, int(self.width()) - Xstart, int(self.height()) - 24);


#                self.v = KHTMLView (self.w, self)

#                self.setCentralWidget (self.v)

#                self.createGUI (self.w)

                self.w.show ();


        def initActions (self):
            # "File" menu items
            self.openAction   = KStdAction.open (self.slotOpen, self.actionCollection ())
            self.quitAction   = KStdAction.quit (self.close, self.actionCollection ())
            # "Edit" menu items
            self.zoomInAction = KStdAction.zoomIn (self.slotZoomIn, self.actionCollection ())
            self.zoomOutAction = KStdAction.zoomOut (self.slotZoomOut, self.actionCollection ())
        
        def initMenus (self):
            fileMenu = QPopupMenu (self)
            self.openAction.plug (fileMenu)
            fileMenu.insertSeparator ()
            self.quitAction.plug (fileMenu)
            self.menuBar ().insertItem (i18n ("&File"), fileMenu)
            
            editMenu = QPopupMenu (self)
            self.zoomInAction.plug (editMenu)
            self.zoomOutAction.plug (editMenu)
            self.menuBar ().insertItem (i18n ("&Edit"), editMenu)
            
            helpMenu = self.helpMenu ("")
            self.menuBar ().insertItem (i18n ("&Help"), helpMenu)


        #------------- slots ---------------------------
        def slotOpen(self, id = -1):
            self.notImpl ("Open")

        #def slotQuit (self):
        #    self.notImpl ("Quit")

        def slotZoomIn (self):
            if self.myzoom <= 270:
                self.myzoom += 30
            self.w.setZoomFactor (self.myzoom)
            #self.notImpl ("Zoom In")

        def slotZoomOut (self):
            if self.myzoom >= 50:
                self.myzoom -= 30
            self.w.setZoomFactor (self.myzoom)
            #self.notImpl ("Zoom Out")

        #def slotNoZoom (self):
            #self.myzoom = 100
            #self.w.setZoomFactor (self.myzoom)

        # slots for our actions
        def optionsShowToolbar (self):
                if self.m_toolbarAction.isChecked():
                        self.toolBar().show()
                else:
                        self.toolBar().hide()

        def optionsShowStatusbar (self):
                if self.m_statusbarAction.isChecked ():
                        self.statusBar().show()
                else:
                        self.statusBar().hide()


        def optionsConfigureKeys (self):
                KKeyDialog.configureActionKeys (self.actionCollection(), self.xmlFile ())


        def optionsConfigureToolbars (self):
                dlg = KEditToolbar (self.actionCollection(), self.xmlFile ())
                if dlg.exec_loop ():
                        self.createGUI(self);


        # some boilerplate left over from pyKLess/KLess
        def queryClose(self):
                #res = KMessageBox.warningYesNoCancel(self,\
                        #i18n("Save changes to Document?<br>(Does not make sense, we know, but it is just a programming example :-)"))
                #if res == KMessageBox.Yes:
	        #// save document here. If saving fails, return FALSE
	                return TRUE

                #elif res == KMessageBox.No:
                #        return TRUE

                #else: #// cancel
	        #        return FALSE

        def queryExit(self):
                #// this slot is invoked in addition when the *last* window is going
                #// to be closed. We could do some final cleanup here.
                return TRUE #// accept

        # I'm not sure the session mgmt stuff here works

        # Session management: save data
        def saveProperties(self, config):
        # This is provided just as an example.
        # It is generally not so good to save the raw contents of an application
        # in its configuration file (as this example does).
        # It is preferable to save the contents in a file on the application's
        # data zone and save an URL to it in the configuration resource.
                config.writeEntry("text", self.edit.text())


        # Session management: read data again
        def readProperties(self, config):
        # See above
                self.edit.setText(config.readEntry("text"))

        def resizeEvent(self, anobject):
                #anobject is not used
                self.w.view ().setGeometry (Xstart, 24, int(self.width()) - Xstart, int(self.height()) - 24);
                tree.setGeometry(0, 24, Xstart, parts.height() - 24)

def isClicked():
    if len(tree.selectedItems()) >= 1:
        IND = tree.itemIndex(tree.selectedItems()[0])
        uprint('click %s' % IND)
        newpath = '/' + theDir + '/' + tocurl[IND]
        uprint(newpath)
        parts.w.openURL (KURL ('zip:' + os.path.abspath(filelist_args[0]) + newpath));

#def KListView():
#    def contentsMouseMoveEvent( e ):
#        if ( e.state() != Qt.NoButton):

#------------- main ----------------------------

global myhfile
global theDir
global Xstart
global debugx

debugx = True
Xstart = 0

# A Human readable description of your program
description = "KoobE - simple epubs reader"
# The version
version = "0.8"

# stuff for the "About" menu
aboutData = KAboutData ("koobedata1", "KoobE2",\
    version, description, KAboutData.License_GPL,\
    "(c) 2007, Matteo Azzali")

aboutData.addAuthor ("Matteo Azzali", "Ebooks reader", "matte.azNOSPAM@libero.it")

# This MUST go here (before KApplication () is called)
try:
    options = [
      ("+file", "File to open")
    ]
    KCmdLineArgs.init (sys.argv, aboutData)
    KCmdLineArgs.addCmdLineOptions(options)
except TypeError:
    KCmdLineArgs.init(sys.argv, aboutData)


args = KCmdLineArgs.parsedArgs()
#for a in range(args.count()):
#         print args.arg(a)
try:
    filelist_args = [args.arg(a).decode("utf-8") for a in range(args.count())]
except:
    filelist_args = [args.arg(a) for a in range(args.count())]

if (len(filelist_args) != 1) or not os.path.isfile(filelist_args[0]):
    print 'too much arguments or file not found.'
    sys.exit(1)

#print filelist_args
MYFILE = 'file:' + os.path.abspath(filelist_args[0])

#zip:pathtofile.epub/OEBPS/pathtospine.html|xml
app = KApplication ()


ThEpub = zipfile.ZipFile(os.path.abspath(filelist_args[0]), 'r')
Container = ThEpub.read('META-INF/container.xml')
#deinit = re.compile('.*rootfile full-path="', re.DOTALL | re.MULTILINE)
#cdeinit = re.compile('" .*|"/>.*', re.DOTALL | re.MULTILINE)
#opfile = cdeinit.sub('', deinit.sub('', Container))

adoc = xml.dom.minidom.parseString(Container)
for node in adoc.getElementsByTagName("rootfile"):
    opfile = node.getAttribute('full-path')

uprint(opfile)
theDir = os.path.dirname(opfile)

TheOpf = ThEpub.read(opfile)
adoc = xml.dom.minidom.parseString(TheOpf)
Container = ''

manifest = []
thid = []
mtype = []
spine = []
linear = []
TOC = False
tocname = ''

for node in adoc.getElementsByTagName("manifest"):
    for node2 in node.getElementsByTagName("item"):
        thid.append(node2.getAttribute('id'))
        manifest.append(node2.getAttribute('href'))
        mtype.append(node2.getAttribute('media-type'))

for node in adoc.getElementsByTagName("spine"):
    if node.hasAttribute('toc'):
        TOC = True
        tocname = node.getAttribute('toc')
    for node2 in node.getElementsByTagName("itemref"):
        spine.append(node2.getAttribute("idref"))
        linear.append(node2.getAttribute("linear"))

TheOpf=''
uprint(TOC)
if TOC:
   uprint(tocname)

trix = ''
tocfile = ''

CNT = 0
FIRST = 0
while CNT < len(spine):
    uprint(spine[CNT] +'\t' + linear[CNT])
    if (linear[CNT] == 'yes') and (FIRST == 0):
        trix = spine[CNT]
        FIRST += 1
    CNT += 1

myhfile = ''

CNT = 0
while CNT < len(manifest):
    uprint(str(CNT) + ':\t %s \t %s \t %s' % ( thid[CNT], manifest[CNT], mtype[CNT]))
    if thid[CNT] == trix:
        myhfile = manifest[CNT]
    if thid[CNT] == tocname:
        tocfile = manifest[CNT]
    CNT += 1

uprint('tocfile: %s' % tocfile)
toctxt = []
tocurl = []
tocclass = []
listItems = {}
ant = []

if TOC:
    uprint(theDir + tocfile)
    Table = ThEpub.read(theDir + '/' + tocfile)
    adoc = xml.dom.minidom.parseString(Table)
    isthefirst = True
    for node in adoc.getElementsByTagName("navPoint"):
        if node.parentNode.tagName == "navMap":
            tocclass.append('h1')
        #elif node.parentNode.parentNode.tagName == "navMap":
        else:
            tocclass.append('h2')
        #else:
        #    tocclass.append('h3')
        AP = 0
        for node2 in node.getElementsByTagName("content"):
            if AP == 0:
                tocurl.append(node2.getAttribute('src'))
                AP += 1
        AP = 0
        for node2 in node.getElementsByTagName("text"):
            if AP == 0:
                namet = ''
                for node3 in node2.childNodes:
                    if node3.nodeType == Node.TEXT_NODE:
                        namet += node3.data
                AP += 1
                toctxt.append(namet)

    CNT = 0
    while CNT < len(tocurl) -1 :
        uprint( tocclass[CNT] + '\t' + toctxt[CNT] + '\t' + tocurl[CNT])
        CNT += 1
    Xstart = 100
    listItems = {"1": {"a":[],\
                 "2": []}}

if (app.isRestored()):
        RESTORE(KLess)
else:
        # no session management: just create one window
        # this is our KParts::MainWindow derived class
        parts = pyPartsMW (None, "pyParts")
        # setting caption
        parts.setCaption(app.makeStdCaption(os.path.basename(filelist_args[0])))
        if TOC:
            #define a side panel
            tree = KListView(parts, "tree")
            parts.connect (tree, SIGNAL ("clicked (QListViewItem *)"), isClicked)
            tree.shadeSortColumn = False
            tree.addColumn (i18n("Chapter"), Xstart - 2)
            tree.setGeometry(0, 24, Xstart, parts.height() - 24)
            tree.setRootIsDecorated (True)
            tree.setVScrollBarMode (QScrollView.AlwaysOn)
            #set sorting column
            tree.setSorting(-1)
            topLevel = listItems.keys ()
            #fill side panel
            CNT = len(toctxt) - 1
            if CNT < 0:
                CNT = 0
            Three = False
            mychild = []
            mychildtxt = []
            while CNT >= 0:
                #uprint( tocclass[CNT] + '\t' + toctxt[CNT] + '\t' + tocurl[CNT])
                if (tocclass[CNT] == 'h2') and (CNT != 0):
                    mychild.append('x' + str(CNT + 1))
                    mychildtxt.append(toctxt[CNT])
                elif (tocclass[CNT] == 'h1') or (CNT == 0):
                    parent = QListViewItem (tree, toctxt[CNT])
                    ACNT = 0
                    for value in mychild:
                        child = QListViewItem (parent, mychildtxt[ACNT])
                        ACNT += 1
                    mychild = []
                    mychildtxt = []
                CNT -= 1

            #if Three:
            #    Xstart = 128

            #for item_1 in topLevel:
                #parent = QListViewItem (tree, item_1)
                #secondLevel = listItems [item_1].keys ()
                #for item_2 in secondLevel:
                    #child = QListViewItem (parent, item_2)
                    #for item_3 in listItems [item_1][item_2]:
                        #QListViewItem (child, item_3)

        if len(sys.argv) > 1:
        # read kcmdlineargs.h for the full unabridged instructions
        # on using KCmdLineArgs, it's pretty confusing at first, but it works
        # This is pretty useless in this program - you might want to
        # expand this in your app (to load a file, etc)
                args = KCmdLineArgs.parsedArgs()

parts.show()
app.exec_loop()
